netfilter-devel.vger.kernel.org archive mirror
 help / color / mirror / Atom feed
From: Pablo Neira Ayuso <pablo@netfilter.org>
To: netfilter-devel@vger.kernel.org
Cc: davem@davemloft.net, netdev@vger.kernel.org
Subject: [PATCH 13/31] selftests: netfilter: add ipvs tunnel test case
Date: Sat, 26 Oct 2019 13:47:15 +0200	[thread overview]
Message-ID: <20191026114733.28111-14-pablo@netfilter.org> (raw)
In-Reply-To: <20191026114733.28111-1-pablo@netfilter.org>

From: Haishuang Yan <yanhaishuang@cmss.chinamobile.com>

Test virtual server via ipip tunnel.

Tested:
# selftests: netfilter: ipvs.sh
# Testing DR mode...
# Testing NAT mode...
# Testing Tunnel mode...
# ipvs.sh: PASS
ok 6 selftests: netfilter: ipvs.sh

Signed-off-by: Haishuang Yan <yanhaishuang@cmss.chinamobile.com>
Signed-off-by: Simon Horman <horms@verge.net.au>
---
 tools/testing/selftests/netfilter/ipvs.sh | 30 ++++++++++++++++++++++++++++++
 1 file changed, 30 insertions(+)

diff --git a/tools/testing/selftests/netfilter/ipvs.sh b/tools/testing/selftests/netfilter/ipvs.sh
index 8b2e618d6a6a..c3b8f90c497e 100755
--- a/tools/testing/selftests/netfilter/ipvs.sh
+++ b/tools/testing/selftests/netfilter/ipvs.sh
@@ -168,6 +168,30 @@ test_nat() {
 	test_service
 }
 
+test_tun() {
+	ip netns exec ns0 ip route add ${vip_v4} via ${gip_v4} dev br0
+
+	ip netns exec ns1 modprobe ipip
+	ip netns exec ns1 ip link set tunl0 up
+	ip netns exec ns1 sysctl -qw net.ipv4.ip_forward=0
+	ip netns exec ns1 sysctl -qw net.ipv4.conf.all.send_redirects=0
+	ip netns exec ns1 sysctl -qw net.ipv4.conf.default.send_redirects=0
+	ip netns exec ns1 ipvsadm -A -t ${vip_v4}:${port} -s rr
+	ip netns exec ns1 ipvsadm -a -i -t ${vip_v4}:${port} -r ${rip_v4}:${port}
+	ip netns exec ns1 ip addr add ${vip_v4}/32 dev lo:1
+
+	ip netns exec ns2 modprobe ipip
+	ip netns exec ns2 ip link set tunl0 up
+	ip netns exec ns2 sysctl -qw net.ipv4.conf.all.arp_ignore=1
+	ip netns exec ns2 sysctl -qw net.ipv4.conf.all.arp_announce=2
+	ip netns exec ns2 sysctl -qw net.ipv4.conf.all.rp_filter=0
+	ip netns exec ns2 sysctl -qw net.ipv4.conf.tunl0.rp_filter=0
+	ip netns exec ns2 sysctl -qw net.ipv4.conf.veth21.rp_filter=0
+	ip netns exec ns2 ip addr add ${vip_v4}/32 dev lo:1
+
+	test_service
+}
+
 run_tests() {
 	local errors=
 
@@ -183,6 +207,12 @@ run_tests() {
 	test_nat
 	errors=$(( $errors + $? ))
 
+	echo "Testing Tunnel mode..."
+	cleanup
+	setup
+	test_tun
+	errors=$(( $errors + $? ))
+
 	return $errors
 }
 
-- 
2.11.0


  parent reply	other threads:[~2019-10-26 11:47 UTC|newest]

Thread overview: 33+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2019-10-26 11:47 [PATCH 00/31] Netfilter/IPVS updates for net-next Pablo Neira Ayuso
2019-10-26 11:47 ` [PATCH 01/31] netfilter: ipset: add a coding-style fix to ip_set_ext_destroy Pablo Neira Ayuso
2019-10-26 11:47 ` [PATCH 02/31] netfilter: ipset: remove inline from static functions in .c files Pablo Neira Ayuso
2019-10-26 11:47 ` [PATCH 03/31] netfilter: ipset: move ip_set_comment functions from ip_set.h to ip_set_core.c Pablo Neira Ayuso
2019-10-26 11:47 ` [PATCH 04/31] netfilter: ipset: move functions " Pablo Neira Ayuso
2019-10-26 11:47 ` [PATCH 05/31] netfilter: ipset: make ip_set_put_flags extern Pablo Neira Ayuso
2019-10-26 11:47 ` [PATCH 06/31] netfilter: ipset: move function to ip_set_bitmap_ip.c Pablo Neira Ayuso
2019-10-26 11:47 ` [PATCH 07/31] netfilter: ipset: move ip_set_get_ip_port() to ip_set_bitmap_port.c Pablo Neira Ayuso
2019-10-26 11:47 ` [PATCH 08/31] ipvs: no need to update skb route entry for local destination packets Pablo Neira Ayuso
2019-10-26 11:47 ` [PATCH 09/31] ipvs: batch __ip_vs_cleanup Pablo Neira Ayuso
2019-10-26 11:47 ` [PATCH 10/31] ipvs: batch __ip_vs_dev_cleanup Pablo Neira Ayuso
2019-10-26 11:47 ` [PATCH 11/31] selftests: netfilter: add ipvs test script Pablo Neira Ayuso
2019-10-26 11:47 ` [PATCH 12/31] selftests: netfilter: add ipvs nat test case Pablo Neira Ayuso
2019-10-26 11:47 ` Pablo Neira Ayuso [this message]
2019-10-26 11:47 ` [PATCH 14/31] netfilter: ecache: document extension area access rules Pablo Neira Ayuso
2019-10-26 11:47 ` [PATCH 15/31] netfilter: ctnetlink: don't dump ct extensions of unconfirmed conntracks Pablo Neira Ayuso
2019-10-26 11:47 ` [PATCH 16/31] netfilter: conntrack: free extension area immediately Pablo Neira Ayuso
2019-10-26 11:47 ` [PATCH 17/31] netfilter: add and use nf_hook_slow_list() Pablo Neira Ayuso
2019-10-26 11:47 ` [PATCH 18/31] netfilter: nft_tproxy: Fix typo in IPv6 module description Pablo Neira Ayuso
2019-10-26 11:47 ` [PATCH 19/31] netfilter: nf_flow_table: move priority to struct nf_flowtable Pablo Neira Ayuso
2019-10-26 11:47 ` [PATCH 20/31] netfilter: nf_tables: dynamically allocate hooks per net_device in flowtables Pablo Neira Ayuso
2019-10-26 11:47 ` [PATCH 21/31] netfilter: nf_tables: allow netdevice to be used only once per flowtable Pablo Neira Ayuso
2019-10-26 11:47 ` [PATCH 22/31] netfilter: nf_tables: increase maximum devices number " Pablo Neira Ayuso
2019-10-26 11:47 ` [PATCH 23/31] netfilter: nf_tables_offload: add nft_flow_block_chain() Pablo Neira Ayuso
2019-10-26 11:47 ` [PATCH 24/31] netfilter: nf_tables_offload: Pass callback list to nft_setup_cb_call() Pablo Neira Ayuso
2019-10-26 11:47 ` [PATCH 25/31] netfilter: nf_tables_offload: add nft_flow_cls_offload_setup() Pablo Neira Ayuso
2019-10-26 11:47 ` [PATCH 26/31] netfilter: nf_tables_offload: remove rules on unregistered device only Pablo Neira Ayuso
2019-10-26 11:47 ` [PATCH 27/31] netfilter: nf_tables: support for multiple devices per netdev hook Pablo Neira Ayuso
2019-10-26 11:47 ` [PATCH 28/31] netfilter: ecache: don't look for ecache extension on dying/unconfirmed conntracks Pablo Neira Ayuso
2019-10-26 11:47 ` [PATCH 29/31] netfilter: nf_tables_offload: add nft_chain_offload_cmd() Pablo Neira Ayuso
2019-10-26 11:47 ` [PATCH 30/31] netfilter: nf_tables_offload: add nft_flow_block_offload_init() Pablo Neira Ayuso
2019-10-26 11:47 ` [PATCH 31/31] netfilter: nf_tables_offload: unbind if multi-device binding fails Pablo Neira Ayuso
2019-10-26 18:36 ` [PATCH 00/31] Netfilter/IPVS updates for net-next David Miller

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20191026114733.28111-14-pablo@netfilter.org \
    --to=pablo@netfilter.org \
    --cc=davem@davemloft.net \
    --cc=netdev@vger.kernel.org \
    --cc=netfilter-devel@vger.kernel.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for NNTP newsgroup(s).